use RAMS 
go

/****** Object:  StoredProcedure [dbo].[usp_pre_treat_datacall]    Script Date: 11/4/2016 10:23:21 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER PROCEDURE [dbo].[usp_pre_treat_datacall]
@UserID int
WITH EXEC AS CALLER
AS
/***********************************************************
** 1 delete duplicates
** 2. postpond section A duplicates
** 3. check existing ones, if found postpond
** 4. archive deleted and postponded records
*************************************************************/

DECLARE @ActionID bigint
DECLARE @StudyTitle varchar(200)
DECLARE @SiteCode varchar(4)
DECLARE @StudyType varchar(1)
    
   
    set @ActionID = 1
    if exists (select distinct Action_ID from data_call_CSV_Arch)
    Begin
    SELECT @ActionID = (max(Action_ID)+1) from Data_call_CSV_arch
    End

-- copy all into archive table
INSERT INTO Data_call_CSV_arch SELECT *,getdate(),@UserID,@ActionID FROM Data_call_CSV;

-- delete absolute duplicates
 WITH ALL_DUP AS(
   SELECT *,
       RN = ROW_NUMBER()OVER(PARTITION BY [A-1],[A-2],[A-3],[A-4],[A-5],[A-6],[A-7],
       [B-1],[B-2],[B-3],[B-4],[B-5],
       [B-6-1],[B-6-2],[B-6-3],[B-6-4],[B-6-5],[B-6-6],[B-6-7],[B-6-8],[B-6-9],[B-6-10],[B-6-11],[B-6-12],
       [B-7],[B-8],[B-9],[B-10],[B-11],[B-12],[B-13],[B-14],[B-15],[B-16],[B-17],[B-18]
       ORDER BY [A-1])
   FROM dbo.Data_call_csv
)
DELETE FROM ALL_DUP WHERE RN > 1 ;

-- postpond section A duplicates
 WITH A_DUP AS(
   SELECT *,
       RN = DENSE_RANK() over (order by [A-1],[A-2],[A-3],[A-4],[A-5],[A-6],[A-7])
   FROM dbo.Data_call_csv
)
INSERT INTO Data_call_CSV_ERR SELECT *,getdate(),@UserID,'Section A duplicates in xls file',@ActionID FROM A_DUP WHERE RN in 
(SELECT DISTINCT RN FROM A_DUP group BY [RN] having count(RN) > 1);

WITH A_DUP2 AS(
   SELECT *,
       RN = DENSE_RANK() over (order by [A-1],[A-2],[A-3],[A-4],[A-5],[A-6],[A-7])
   FROM dbo.Data_call_csv
)
DELETE FROM  A_DUP2 WHERE RN in 
(SELECT DISTINCT RN FROM A_DUP2 group BY [RN] having count(RN) > 1);

-- If found looks same study entry, postpond
 
 IF exists (
            select '--' + substring(AssignedID, 15,1) + substring(AssignedID,1,4) + ltrim(rtrim(Title))+ '--' 
            from Studies
            intersect
            select '--'+Substring([A-7],1,1)+Substring([A-6],1,4) + ltrim(rtrim([A-1]))+'--' 
            from dbo.data_call_csv
            )
  BEGIN
  INSERT INTO Data_call_CSV_ERR SELECT *,1,getdate(),@UserID,'found existing records',@ActionID 
  FROM Data_call_CSV
  WHERE  '--'+Substring([A-7],1,1)+Substring([A-6],1,4) + ltrim(rtrim([A-1]))+'--' in (
          select '--' + substring(AssignedID, 15,1) + substring(AssignedID,1,4) + ltrim(rtrim(Title))+ '--' as matchstring
          from Studies
          intersect
          select '--'+Substring([A-7],1,1)+Substring([A-6],1,4) + ltrim(rtrim([A-1]))+'--' 
          from dbo.data_call_csv
          )
  DELETE FROM Data_call_CSV 
  WHERE  '--'+Substring([A-7],1,1)+Substring([A-6],1,4) + ltrim(rtrim([A-1]))+'--' in (
          select '--' + substring(AssignedID, 15,1) + substring(AssignedID,1,4) + ltrim(rtrim(Title))+ '--' as matchstring
          from Studies
          intersect
          select '--'+Substring([A-7],1,1)+Substring([A-6],1,4) + ltrim(rtrim([A-1]))+'--' 
          from dbo.data_call_csv
          )
   END

GO

/****** Object:  StoredProcedure [dbo].[usp_update_pi_for_datacall]    Script Date: 11/4/2016 10:23:21 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- 5.3. usp_update_pi_for_datacall

ALTER PROCEDURE [dbo].[usp_update_pi_for_datacall]
WITH EXEC AS CALLER
AS
/******************************************************************************
**		Type: sproc
**		File: 
**		Name: N/A
**		Desc: compare ram data call users, va logon ids, with users table entries, insert into users table if find new ones
**		Purpose: 
**	    Usage: 
**	    exec : 
**
*******************************************************************************/
BEGIN
    SET TRANSACTION ISOLATION LEVEL REPEATABLE READ
    SET NOCOUNT ON

    DECLARE @StudyStatusID INT
    DECLARE @AssignedID varchar(15)
    DECLARE @PIVAID varchar(100)
    DECLARE @COPIVAID varchar(100)
    DECLARE @PINAME varchar(50)
    DECLARE @COPINAME varchar(50)
    DECLARE @StudyExpDate datetime
    DECLARE @UsersID INT
    
    DECLARE @mytempcount int
    DECLARE @tempcount int

    
    DECLARE @ActionID bigint

    SELECT @ActionID = MAX(Action_ID) from dbo.Data_call_CSV_processed
    if @ActionID IS NULL
    BEGIN 
    SET @ActionID = 1
    END
    
    
    set rowcount 0
    
select distinct
           StudystatusID,
           PI_VA_ID,
           b.usersID
    into #mytemp
    from dbo.Data_call_process_summary a
    join dbo.users b on a.PI_VA_ID = b.LoginName
    where action_id = @ActionID
    
    set @PIVAID = ( select top 1 pi_va_id from #mytemp)
    set @StudyStatusID = ( select top 1 StudyStatusID from #mytemp)
    set @UsersID = ( select top 1 UsersID from #mytemp)
    
 SET @mytempcount = 1
 WHILE @mytempcount < ((SELECT COUNT(*) FROM #mytemp)+1)
  begin
    
    update dbo.study_status set CreatedBy = @UsersID
    where StudyStatusID = @StudyStatusID
    
   update dbo.study_status set UpdatedBy = @UsersID
    where StudyStatusID = @StudyStatusID
     
     DELETE #mytemp where PI_VA_ID = @PIVAID and 
                       StudyStatusID = @StudyStatusID and
                       UsersID = @UsersID
  
      set rowcount 1
   
    set @PIVAID = ( select top 1 pi_va_id from #mytemp)
    set @StudyStatusID = ( select top 1 StudyStatusID from #mytemp)
    set @UsersID = ( select top 1 UsersID from #mytemp)
    
 END
 
 DROP table #mytemp

 SET rowcount 0

 end
 
 go
/****** STORED PROCEDURES
Object:  StoredProcedure [dbo].[usp_check_users_for_datacall]    Script Date: 11/4/2016 10:23:21 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER PROCEDURE [dbo].[usp_check_users_for_datacall]
WITH EXEC AS CALLER
AS
/******************************************************************************
**		Type: sproc
**		File: 
**		Name: N/A
**		Desc: compare ram data call users, va logon ids, with users table entries, insert into users table if find new ones
**		Purpose: 
**	    Usage: 
**	    exec : 
**
*******************************************************************************/
BEGIN
    SET TRANSACTION ISOLATION LEVEL REPEATABLE READ
    SET NOCOUNT ON

    DECLARE @StudyStatusID INT
    DECLARE @AssignedID varchar(15)
    DECLARE @PIVAID varchar(100)
    DECLARE @COPIVAID varchar(100)
    DECLARE @PINAME varchar(50)
    DECLARE @COPINAME varchar(50)
    DECLARE @StudyExpDate datetime
    DECLARE @UsersID INT
    
    DECLARE @mytempcount int
    DECLARE @tempcount int

    
    DECLARE @ActionID bigint

    SELECT @ActionID = MAX(Action_ID) from dbo.Data_call_CSV_arch
    if @ActionID IS NULL
    BEGIN 
    SET @ActionID = 1
    END
    
    
    set rowcount 0
    
    select distinct
           PI_VA_ID
    into #mytemp
    from dbo.Data_call_process_summary
    where action_id = @ActionID and (
    PI_VA_ID not in ( select Loginname from dbo.users))
 
    set rowcount 1
    set @PIVAID = ( select top 1 pi_va_id from #mytemp)
    
 SET @mytempcount = 1
 WHILE @mytempcount < ((SELECT COUNT(*) FROM #mytemp)+1)
  begin
    set rowcount 0
    set @UsersID = (select (max(usersID) + 1) from dbo.users)
    
    SET IDENTITY_INSERT dbo.Users ON
    
    insert into dbo.users (
                       [UsersID],
                       [LoginName],
                       [DisplayName]
                          )
                 values(
                       @UsersID,
                       @PIVAID,
                       @PIVAID
                       )
    
    SET IDENTITY_INSERT dbo.Users OFF

      
     
     DELETE #mytemp where PI_VA_ID = @PIVAID
  
      set rowcount 1
   
    set @PIVAID = ( select top 1 pi_va_id from #mytemp)
 
 END
 
 DROP table #mytemp

 SET rowcount 0
 
 select distinct
           CO_PI_VA_ID
    into #mytemp2
    from dbo.Data_call_process_summary
    where action_id = @ActionID and (
    CO_PI_VA_ID not in ( select loginname from dbo.users) and CO_PI_VA_ID is not null)
 
    set rowcount 1
    set @COPIVAID = ( select top 1 co_pi_va_id from #mytemp2)
    
    SET @mytempcount = 1
    WHILE @mytempcount < ((SELECT COUNT(*) FROM #mytemp2)+1)
    begin
    set rowcount 0
    set @UsersID = (select (max(usersID) + 1) from dbo.users)
    
    SET IDENTITY_INSERT dbo.Users ON
    insert into dbo.users (
                       [UsersID],
                       [LoginName],
                       [DisplayName]
                       )
                 values(
                       @UsersID,
                       @COPIVAID,
                       @COPIVAID
                       )
    SET IDENTITY_INSERT dbo.Users OFF

      
     
     DELETE #mytemp2 where CO_PI_VA_ID = @COPIVAID 
  
      set rowcount 1
   
    set @COPIVAID = ( select top 1 co_pi_va_id from #mytemp2)
 
 END
 DROP table #mytemp2

 SET rowcount 0

END

GO
/****** Object:  StoredProcedure [dbo].[usp_insert_datacall_into_rams]    Script Date: 11/4/2016 10:23:21 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- Batch submitted through debugger: SQLQuery18.sql|7|0|C:\Users\      JOGIAK0\AppData\Local\Temp\2\~vsE84C.sql
-- Batch submitted through debugger: SQLQuery7.sql|7|0|C:\Users\      JOGIAK0\AppData\Local\Temp\2\~vs43CE.sql
ALTER PROCEDURE [dbo].[usp_insert_datacall_into_rams]
@idout bigint OUTPUT
WITH EXEC AS CALLER
AS
/******************************************************************************
**		Type: sproc
**		File: usp_insert_datacall_into_rams
**		Name: N/A
**		Desc: get data from datacall view, get new rams studyid, insert into the section a and b
**          data into RAMS table: studies, study_status and questions_reponses
**		Last Modified:  25, Jan, 2016 (SAT)
**		Version: R1502
**
*******************************************************************************/
BEGIN
    SET TRANSACTION ISOLATION LEVEL REPEATABLE READ
    SET NOCOUNT ON

    DECLARE @StudyStatusID INT
    DECLARE @StudyID INT
    DECLARE @StudyMembersID INT
    DECLARE @SiteCode varchar(5)
	DECLARE @FacilitiesID INT
    DECLARE @InitStudyType CHAR(1)
    DECLARE @AssignedID varchar(15)
    DECLARE @StudyTitle Varchar(200)
    DECLARE @PIVAID varchar(100)
    DECLARE @COPIVAID varchar(100)
    DECLARE @StudyExpDate datetime
    DECLARE @Server_ID INT
    DECLARE @UserID INT
    DECLARE @FormVersionsID INT
    DECLARE @QuestionsResponsesID int
    DECLARE @QuestionsID  int
    DECLARE @AnswersID    int
    DECLARE @CheckboxIndex tinyint
    DECLARE @Response  varchar(500)
    DECLARE @mytempcount int
    DECLARE @tempcount int
    DECLARE @Answers   VARCHAR(8)
	DECLARE @randomSeed float
    DECLARE @ActionID bigint
    
    set @FormVersionsID = (select FormVersionsID from dbo.Form_Versions where FileName ='MainApplication.csv')
    Set @userID = (select UsersID from dbo.users where LoginName = 'SSISUser')
    
    execute dbo.usp_pre_treat_datacall @UserID
    
    set rowcount 0
    
    SELECT @ActionID = MAX(Action_ID) from dbo.Data_call_CSV_arch
    if @ActionID IS NULL
    BEGIN 
    SET @ActionID = 1
    END

    select distinct
           convert(varchar(200),[A-1]) as study_title, 
           convert(char(10),[A-6]) as site_code, 
           convert(varchar(10),[A-7]) as study_type,
           convert(varchar(100),[A-2-1]) as pi_va_id,
           convert(varchar(100),[A-4-1]) as copi_va_id,
           [A-8] as Study_exp_date
    into #mytemp
    from dbo.Data_call_CSV

    set rowcount 1
    set @StudyTitle = ( select top 1 study_title from #mytemp)
    set @SiteCode = ( select top 1 site_code from #mytemp)
    set @InitStudyType = ( select top 1 substring(study_type,1,1) from #mytemp)
    set @PIVAID = ( select top 1 pi_va_id from #mytemp)
    set @COPIVAID = ( select top 1 copi_va_id from #mytemp)
    set @StudyExpDate = ( select top 1 Study_exp_date from #mytemp)
	SET @mytempcount = 1
 WHILE @mytempcount < ((SELECT COUNT(*) FROM #mytemp)+1)
  begin
    set rowcount 0
 
    set @AssignedID = NULL;
    select @studyID = (max(studiesID)+ 1) from dbo.studies;
    select @studyStatusID = (max(studyStatusID) + 1) from Study_Status;
    select @StudyMembersID = (MAX(Study_MembersID)+1) from Study_Members;
	
	-- We added this in order to facilitate the 5 digit alphanumeric research center codes
	set @FacilitiesID = (select FacilitiesID from Facilities where Code = @SiteCode)
	set @randomSeed = rand()

    select @AssignedID = rams.dbo.GETSTUDYID(@Sitecode, @randomSeed, @InitStudyType);

    SET IDENTITY_INSERT Studies ON
    insert into studies (
                       studiesID,
                       AssignedID,
                       ParentStudiesID,
                       Title, 
                       FacilitiesID,
                       SynchronizedTimestamp,
                       FormVersionsID
                       )
                 values(
                       @StudyID,
                       @AssignedID,
                       null,
                       @StudyTitle,
                       @FacilitiesID,
                       getdate(),
                       @FormVersionsID
                       )
                       
    SET IDENTITY_INSERT Studies OFF
    
    SET IDENTITY_INSERT Study_status ON

    insert into study_Status (
                       StudyStatusID, 
                       studiesID,
                       StageCounter,
                       StudyStatesID,
                       CreatedAt, 
                       CreatedBy, 
                       UpdatedAt, 
                       UpdatedBy
                       )
                 values(
                       @studyStatusID,
                       @StudyID,
                       1,
                       2,
                       getdate(),
                       @UserID,
                       getdate(),
                       @UserID
                       )

    SET IDENTITY_INSERT Study_status OFF
    
    Insert into [dbo].[data_call_process_summary] (
                       [Action_ID],
                       [AssignedID],
                       [Study_Title],
                       [Study_Exp_Date],
                       [StudyStatusID],
                       [Site_Code],
                       [PI_VA_ID],
                       [CO_PI_VA_ID],
                       [Study_Type],
                       [Action_Type],
                       [loadtime],
                       [loadby]
                       )
                       Values (
                       @ActionID,
                       @AssignedID,
                       @StudyTitle,
                       @StudyExpDate,
                       @StudyStatusID,
                       @SiteCode,
                       @PIVAID,
                       @COPIVAID,
                       @InitStudyType,
                       'Insert',
                       getdate(),
                       @UserID
                       )
                       
    SELECT study_Title, Answers, questionsID, answersID, answerValue
    INTO #mytemp2
    FROM dbo.V_data_call_csv_nonflat_mapped 
    WHerE answers not in (N'A-6',N'A-7',N'A-8') and study_title = @StudyTitle
    
    
    
    SET @tempcount = 1
    
   WHILE @tempcount < ((SELECT COUNT(*) FROM #mytemp2 WHERE study_title = @StudyTitle)+1) -- for section B part
    BEGIN
    
      SET IDENTITY_INSERT Questions_Responses ON
    
      select @QuestionsResponsesID = (max(QuestionsResponsesID) + 1) from Questions_Responses
      
      SET rowcount 1
      select @QuestionsID = QuestionsID, @Answers = convert(varchar(8), answers), @AnswersID = AnswersID, @Response = answerValue 
      from #mytemp2 where study_title = @StudyTitle
      
      IF @AnswersID = 0 
      begin
      set @answersID = NULL
      end 
      
      SET @CheckboxIndex = NULL
      if exists ( 
      select answerposition  from v_qlist_datacall
      where formsID in (153,160) and convert(varchar(10),datatype) = 'Checkbox' and answersID = @AnswersID)
      BEGIN
      select @CheckboxIndex = answerposition from v_qlist_datacall
      where formsID in (153,160) and convert(varchar(10),datatype) = 'Checkbox' and answersID = @AnswersID
      END
      
    INSERT INTO Questions_Responses (
                       QuestionsResponsesID, 
                       StudyStatusID, 
                       QuestionsID, 
                       CheckboxIndex, 
                       AnswersID, 
                       Response, 
                       UpdatedAt
                       )
                VALUES (
                       @QuestionsResponsesID,
                       @StudyStatusID,
                       @QuestionsID,
                       @CheckboxIndex,
                       @AnswersID,
                       @Response,
                       Getdate()
                       )
      DELETE #mytemp2 
      where questionsID = @QuestionsID and study_title = @StudyTitle and convert(varchar(8),Answers) = @Answers
      
      SET IDENTITY_INSERT Questions_Responses OFF
      
      END
      set rowcount 0

     
     drop table #mytemp2
     
     DELETE #mytemp where study_title = @StudyTitle and 
                       site_code = @Sitecode and 
                       substring(study_type,1,1) = @InitStudyType
  
  set rowcount 1  -- load next row in data_call_cvs
    set @StudyTitle = ( select top 1 study_title from #mytemp)
    set @SiteCode = ( select top 1 site_code from #mytemp)
    set @InitStudyType = ( select top 1 substring(study_type,1,1) from #mytemp)
    set @PIVAID = ( select top 1 pi_va_id from #mytemp)
    set @COPIVAID = ( select top 1 copi_va_id from #mytemp)
    set @StudyExpDate = ( select top 1 Study_exp_date from #mytemp)
  --select @StudyTitle = study_title,@SiteCode = site_code, @InitStudyType = substring(study_type,1,1) from #mytemp
 
 END
 
 DROP table #mytemp

 SET rowcount 0
 
 BEGIN
 INSERT INTO dbo.Data_call_CSV_processed SELECT *,getdate(),@UserID,@ActionID FROM Data_call_CSV
 DELETE FROM dbo.Data_call_CSV
 END
 
 execute dbo.usp_check_users_for_datacall
 execute dbo.usp_update_pi_for_datacall
 
END


GO

