var itemInfo; // data after JSON is parsed into dictionary
// var currentUrl = window.location.href;
// var realUrl = currentUrl.substring(0, currentUrl.indexOf("SiteAssets")-1);
// var restPath = "https://" + window.location.hostname + ":8888/RAMS-2.2.0/";
var realUrl = dynamicSharepointURL;
var restPath = dynamicWebServiceURL;
var requestDigest = null;
var array = [];
var count = 0;

function generateClosedWithdrawnReportData() {
   var url = null;
   getApplicationData(url);
}

function getApplicationData(url) {
   var initialUrl = realUrl + "_api/web/lists/getbytitle('Application')/items?$filter= ApplicationType eq 'Closeout'&$select=Study_ID,Title,ExpiringDate,CIRB_ID,ApplicationType,AssignedIRBAdministrator/ID,AssignedIRBAdministrator/Title,PrincipalInvestigator/ID,PrincipalInvestigator/Title,CoPI/ID,CoPI/Title,PrimaryReviewers/ID,PrimaryReviewers/Title,Reviewers/ID,Reviewers/Title,FacilityLookup/FacilityName,ParentStudyID&$expand=AssignedIRBAdministrator,PrincipalInvestigator,CoPI,PrimaryReviewers,Reviewers,FacilityLookup";
   var appDataUrl;
   if (url) {
      appDataUrl = url;
   } else {
      appDataUrl = initialUrl;
   }
   var studyActionData = null;
   // THIS IS THE MAIN QUERY TO RETRIEVE STUDY ITEMS FROM APPLICATION LIST.
   $
         .ajax({
            url : appDataUrl,
            method : "GET",
            headers : {
               "Accept" : "application/json; odata=verbose"
            },
            success : function(data) {
               for (var i = 0; i < data.d.results.length; i++) {
                  getDataPt1(data.d.results[i]);
               }
               if (data.d.__next) {
                  getApplicationData(data.d.__next);
               }

            },
            error : function(data) {
               console.log("Error " + data);
            }
         });
}

function getDataPt1(itemInfo) {
   $.ajax({
      url : restPath + "study/" + itemInfo.Study_ID + "/responses/1/rollup",
      method : "GET",
      headers : {
         "Accept" : "application/json; odata=verbose"
      },
      success : function(data) {
         var type = "N/A";
         for (var j = 0; j < data.responses.length; j++) {
            if (data.responses[j].questionsID == "13650") {
               console.log("Checkbox:" + data.responses[j].answersID);
               type = data.responses[j].checkboxIndex;
               getDataPt2(itemInfo, type);
            }
         }
      },
      error : function(json) {
         console.log("Error: " + JSON.stringify(data));
         type = "unknown";
         getDataPt2(itemInfo, type);
      }
   });
}

function getDataPt2(itemInfo, agency) {
   var expirDate;
   var studyID = itemInfo.Study_ID;
   var parentStudyID = itemInfo.ParentStudyID;
   var cirbTag = itemInfo.CIRB_ID
   var coPI = itemInfo.CoPI;
   var PI = itemInfo.PrincipalInvestigator;
   var studyTitle = itemInfo.Title;
   var expeditedReviewCategory = "N/A";
   var reviewType = "N/A";

   // check for expiration date
   if (itemInfo.ExpiringDate == null) {
      expirDate = "N/A";
   } else {
      expirDate = itemInfo.ExpiringDate.split("T")[0];
   }
   // check for PI and CoPI values
   if (coPI.Title == null) {
      coPI = "N/A";
   } else {
      coPI = coPI.Title;
   }
   if (PI == null) {
      PI = "N/A";
   } else {
      PI = itemInfo.PrincipalInvestigator.Title;
   }

   // check for CIRB tag value
   if (cirbTag == null) {
      cirbTag = "N/A";
   }

   // check for expedited category
   if (!(itemInfo.ApplicationType.split(" ")[1] == undefined)) {
      expeditedReviewCategory = getCategories(itemInfo.ApplicationType.substring(8));
   }

   array.push({
      "CIRB_Number" : cirbTag,
      "Study_ID" : studyID,
      "Date_Approved" : "N/A",
      "Protocol_Title" : studyTitle,
      "PI" : PI,
      "CoPI" : coPI,
      "Expedited_Type" : expeditedReviewCategory,
      "IRB_Manager" : "N/A",
      "agency" : agency,
      "Reviewer" : "N/A",
      "Date_Final_Approval" : "N/A", // don't have value
      "Date_Submitted" : "N/A"
   });
   // 2) IN THE LOOP, IT WILL GO TO RETRIEVE STATUS DETAILS FROM RAMS_DB FOR EACH STUDY IN THE MAIN QUERY.

   $.ajax({
      url : restPath + "study/" + studyID,
      method : "GET",
      async : false,
      headers : {
         "Accept" : "application/json; odata=verbose"
      },
      success : function(data) {
         // 3) THIS SECOND AJAX QUERY IS GETTING THE study JSON OBJECT FROM RAMS_DB FOR EACH STUDY IN MAIN QUERY. IF
         // THERE ARE STATUS COLLECTION ASSOCIATED WITH THIS STUDY OBJECT, IT WILL BUILD STATUS STRING USING
         // getStatusText FUNCTION. IT WILL THEN UPDATE THE STATUS PROPERTY OF ARRAY OBJECT OF THAT STUDY IN array USING
         // updateStatus() FUNCTION.
         var status = getStatusText(data);
         updateStatus(data.assignedID, status); // add dates to array

         getParentStudyData(parentStudyID, data.assignedID); // get parent study's admin & reviewers
         getLocalSiteNumber(parentStudyID, studyID); // get number of local sites for parent study

         $("#example-table-theme").tabulator("setData", array);
      },
      error : function(data) {
         $("#example-table-theme").tabulator("setData", array);
      }

   });
}

function getCategories(checkBoxes) {

   var indexArray = findIndexes('*', checkBoxes);
   var array = RAMS.Environment.SharePoint.List.Application.ExpeditedCategories;
   var categories = "";
   for ( var j in indexArray) {
      categories = categories + array[indexArray[j]] + String.fromCharCode(13);
   }

   return categories;

}

function findIndexes(char, str) {
   for (var a = [], i = str.length; i--;)
      if (str[i] == char)
         a.push(i);
   return a;
}

function findIndexes1(substring, string) {
   var a = [], i = -1;
   while ((i = string.indexOf(substring, i + 1)) >= 0)
      a.push(i);
   return a;
}

function updateStatus(studyID, status) {
   for ( var i in array) {
      if (array[i].Study_ID == studyID) {

         array[i].Date_Approved = status[0];
         array[i].Date_Submitted = status[1];
         break; // Stop this loop, we found it!
      }
   }
}

/*
 * Return study approval and submission date
 */
function getStatusText(studyObject) {

   var study = studyObject;
   var approvalDate = "N/A";
   var finalApprovalDate = "N/A";
   var submissionDate = "N/A";

   for ( var j in study.studyStatusCollection) {
      if (study.studyStatusCollection[j].studyState.name.trim() == "Approved") {
         approvalDate = study.studyStatusCollection[j].createdAt.split("T")[0];
      }

      if (study.studyStatusCollection[j].studyState.name.trim() == "Submitted") {
         submissionDate = study.studyStatusCollection[j].createdAt.split("T")[0];
      }

   }

   return [
         approvalDate, submissionDate
   ];

}

/*
 * Add approval date and submission date found to its associated study in the array
 */
function updateFields(studyID, json) {
   var data = json.d.results[0];
   var manager = "N/A";
   var reviewers = "N/A";

   for ( var i in array) {
      if (array[i].Study_ID == studyID) {

         if (data.AssignedIRBAdministrator.Title != undefined) {
            manager = data.AssignedIRBAdministrator.Title;
         }

         if (data.PrimaryReviewers.Title != undefined) {
            if (reviewers == "N/A") {
               reviewers = data.PrimaryReviewers.Title;
            } else {
               reviewers = reviewers + ", " + data.PrimaryReviewers.Title;
            }
         }

         if (data.Reviewers.results != undefined) {
            for (var j = 0; j < data.Reviewers.results.length; j++) {
               if (reviewers == "N/A") {
                  reviewers = data.Reviewers.results[j].Title;
               } else {
                  reviewers = reviewers + ", " + data.Reviewers.results[j].Title;
               }
            }
         }

         array[i].IRB_Manager = manager;
         array[i].Reviewer = reviewers;

         break; // Stop this loop, we found it!
      }
   }
}

/*
 * Get the admin and reviewers of the parent study
 */
function getParentStudyData(parentStudyID, studyID) {
   $
         .ajax({
            url : realUrl
                  + "_api/web/lists/getbytitle('Application')/items?$filter=Study_ID eq '"
                  + parentStudyID
                  + "'"
                  + "&$select=AssignedIRBAdministrator/ID,AssignedIRBAdministrator/Title,PrimaryReviewers/ID,PrimaryReviewers/Title,Reviewers/ID,Reviewers/Title&$expand=AssignedIRBAdministrator,PrimaryReviewers,Reviewers",
            method : "GET",
            headers : {
               "Accept" : "application/json; odata=verbose"
            },
            async : false,
            success : function(json) {
               if (json.d.results.length > 0) {
                  updateFields(studyID, json);
               }
            },
            error : function(json) {
               console.log("Error: " + JSON.stringify(json));
            }
         });
}

/*
 * Add the local site count to its associated study
 */
function updateSiteNumber(studyID, json) {
   var siteNumber = json.d.results.length;

   for ( var i in array) {
      if (array[i].Study_ID == studyID) {
         array[i].Site_Count = siteNumber;

         break; // Stop this loop, we found it!
      }
   }
}

/*
 * Get the number of local site applications associated with the same parent study application
 */
function getLocalSiteNumber(parentStudyID, studyID) {
   $.ajax({
      url : realUrl + "_api/web/lists/getbytitle('Application')/items?$filter=ParentStudyID eq '" + parentStudyID + "'"
            + " and ApplicationSiteType eq 'Local'",
      method : "GET",
      headers : {
         "Accept" : "application/json; odata=verbose"
      },
      async : false,
      success : function(json) {
         if (json.d.results.length > 0) {
            updateSiteNumber(studyID, json);
         }
      },
      error : function(json) {
         console.log("Error: " + JSON.stringify(json));
      }
   });

}