Add-PSSnapin Microsoft.SharePoint.PowerShell

if ((get-module | Where-Object({$_.Name -eq 'RAMS_Module_Util'}) ) -eq $null) {
    Import-Module .\RAMS_Module_Util.psm1 -Verbose
}
$weburl = Get-SiteURL
$webSite = Get-SPWeb $weburl

#CREATE SITE COLUMNS
Write-Host "CREATING SITE COLUMNS" -ForegroundColor Green

#Chita Per The SDD If possible can we enhance the Set-SiteColumn To Allow for the below
#Needs to be updated to have Max Size = 3 and Not Required if possible
Set-SiteColumn -web $webSite -sFieldDisplayName "Adverse Reportable Event" -sFieldStaticName "AdverseReportableEvent" -sFieldInternalName "AdverseReportableEvent" -sFieldType "Text"  -spFieldGroup "RAMS IRB" 
Set-SiteColumn -web $webSite -sFieldDisplayName "Deviation Reportable Event" -sFieldStaticName "DeviationReportableEvent" -sFieldInternalName "DeviationReportableEvent" -sFieldType "Text"  -spFieldGroup "RAMS IRB" 
	
#ADD SITE COLUMNS TO CONTENT TYPE
Write-Host "ADDING SITECOLUMNS TO CONTENT TYPE" -ForegroundColor Green

Add-SiteColumnToCT -web $webSite -ctName "Application CT" -sFieldInternalName "AdverseReportableEvent" -sFieldStaticName "AdverseReportableEvent"
Add-SiteColumnToCT -web $webSite -ctName "Application CT" -sFieldInternalName "DeviationReportableEvent" -sFieldStaticName "DeviationReportableEvent"

#clean
if($webSite -ne $null) {
    $webSite.Dispose();
}