Add-PSSnapin Microsoft.SharePoint.PowerShell

if ((get-module | Where-Object({$_.Name -eq 'RAMS_Module_Util'}) ) -eq $null) {
    Import-Module .\RAMS_Module_Util.psm1 -Verbose
}
$weburl = Get-SiteURL
$webSite = Get-SPWeb $weburl

#CREATE SITE COLUMNS
Write-Host "CREATING SITE COLUMNS" -ForegroundColor Green

Set-SiteColumn -web $webSite -sFieldDisplayName "Off-site Waiver Requests" -sFieldStaticName "OffsiteWaiverRequests" -sFieldInternalName "OffsiteWaiverRequests" -sFieldType "Note"  -spFieldGroup "RAMS IRB" 
	

#ADD SITE COLUMNS TO CONTENT TYPE
Write-Host "ADDING SITECOLUMNS TO CONTENT TYPE" -ForegroundColor Green

Add-SiteColumnToCT -web $webSite -ctName "Application CT" -sFieldInternalName "OffsiteWaiverRequests" -sFieldStaticName "OffsiteWaiverRequests"

#clean
if($webSite -ne $null) {
    $webSite.Dispose();
}