$website = (Get-SiteWeb)
$newCommittees = @("SC1","SC2","SC3")

#create new calendard list in all facilities
$newCommittees | % {    
    $newCommiteeName = $_
    $website.Webs | % {
        $facilitySite = $_

        #create new SP documents and calendar
        $newDoc = New-SPList -web $facilitySite -newCommiteeName $newCommiteeName -template Documents -Verbose         
        $newCalendar = New-SPList -web $facilitySite -newCommiteeName $newCommiteeName -template Calendar -Verbose         

        #Create meeting minute lookup
        New-MeetingMinuteLookup -web $facilitySite -committee $newCommiteeName
    }
}

$website = (Get-SiteWeb)
$newCommittees | % {    
    $newCommiteeName = $_
    $website.Webs | % {
        $facilitySite = $_
        #add new column to the list
        $newCalendar = $_.Lists.TryGetList("$newCommiteeName Calendar")       
        $newField = $facilitySite.Fields.TryGetFieldByStaticName("$($newCommiteeName)MeetingMinuteLookup")
        $newField1 = $facilitySite.Fields.TryGetFieldByStaticName("SubmittedApplicationLookup")        
        $newCalendar.Fields.Add($newField);
        $newCalendar.Fields.Add($newField1);
        $newCalendar.Update()

        #remove redundant attendees from the forms.
        $newCalendar = [Microsoft.SharePoint.SPList]$_.Lists.TryGetList("$newCommiteeName Calendar") 
        $toRemoveField = $newCalendar.Fields.TryGetFieldByStaticName("Attendees")
        $toRemoveField.ShowInNewForm = $false
        $toRemoveField.ShowInEditForm = $false
        $toRemoveField.Update($true)
        $newCalendar.Update()

        #update Calendar view
        Update-CalendarView -web $facilitySite -committee $newCommiteeName
    }
}



