Add-PSSnapin Microsoft.SharePoint.Powershell
#Chita please turn versioning on for document library

function GetAllWebs($url)
{
  
    try
    {
        Write-Host ([String]::Format("Procesing web {0}",$w.Url)) -foregroundcolor Blue
        if($w.Webs.Count -gt 0)
        {
            foreach($web in $w.Webs)
            {
              DeleteInvestigatorDocumentLibrary $web;
              CreateInvestigatorDocumentLibrary $web;
            }
        }
    }
    catch
    {
        Write-Host ([String]::Format("Error processing web at $url, with Exception: {0}", $_.Exception.Message)) -foregroundcolor Red
    }   
}

function DeleteInvestigatorDocumentLibrary($web) 
{
  $list = $web.Lists.TryGetList("Investigator Documents")
    if($list -ne $null)
    {
        # The list already exists
        $ListToDeleteName = "Investigator Documents"
	    echo "Deleting List"   $ListToDeleteName
 
	    #Get Web and List objects
	    $list = $web.Lists[$ListToDeleteName]
	
	    #Reset the "Allow Deletion" Flag
	    $list.AllowDeletion = $true
       
	    $list.Update()
	    $list.Delete()
    }	
}

function CreateInvestigatorDocumentLibrary($web) 
{       
	echo "This Investigator Document Library Is created" $web.url
	$SPTemplate = [Microsoft.Sharepoint.SPListTemplateType]::DocumentLibrary
	$web.Lists.Add("InvestigatorDocuments","InvestigatorDocuments",$SPTemplate)
	       
	$list = $web.Lists.TryGetList("InvestigatorDocuments")

	if($list -ne $null)
	{
		$list.Title="Investigator Documents"
		$list.Update()
	}
}

#This is to test the driver contains a $siteUrl
#$siteUrl="https://vaww.idev.ram.msp.va.gov/sites/IRBApplications/";
$w = Get-SPWeb $siteUrl;
GetAllWebs($siteUrl)