<#

RAMS Release: 2.3
Last updated: May 14th 2018
Author: By-Light

Assumptions :
- The user executing the script must be part of the Site Collection Administration group.

#>

#SPSite
Param( [Parameter(Mandatory=$True)]
	[string]$siteUrl,
	
	[Parameter(Mandatory=$True)]
	[string]$fileLocationPS,
	
	[Parameter(Mandatory=$True)]
	[string]$fileLocationTemplate,
	
	[Parameter(Mandatory=$True)]
	[string]$fileLocationSiteAsset,
	
	[Parameter(Mandatory=$True)]
	[string]$reportTargetServerName,
	
	[Parameter(Mandatory=$True)]
	[string]$reportSourceDirectory,
	
	[Parameter(Mandatory=$True)]
	[string]$wfTempFileLocation,
	
	# DataSources Connection string Table
	[Parameter(Mandatory=$True)]
	[hashtable]$rdsConnStringTable,
	
	# DataSource Credentials: Username and Password if needed
	[Parameter(Mandatory=$True)]
	[hashtable]$rdsCredentialsTable

)


$perComplete = 0 
$count = 3
$ConfirmPreference = "None"



Write-Progress -Activity "RAMS 2.3 Deployment - Step: 0.0 [NewCommittteeStatus]" -PercentComplete $perComplete
# include the NewCommittteeStatus.
$scriptInc = Join-Path $fileLocationPS NewCommittteeStatus.ps1
echo $scriptInc
. $scriptInc


Write-Progress -Activity "RAMS 2.3 Deployment - Step: 0.1 [NewFacilityInfo]" -PercentComplete $perComplete
# include the NewFacilityInfo.
$scriptInc = Join-Path $fileLocationPS NewFacilityInfo.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 0.2 [NewCommittteeInfo]" -PercentComplete $perComplete
# include the NewCommittteeInfo.
$scriptInc = Join-Path $fileLocationPS NewCommittteeInfo.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 0.3 [UpdateApplicationList]" -PercentComplete $perComplete
# include the UpdateApplicationList.
$scriptInc = Join-Path $fileLocationPS UpdateApplicationList.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 0.4 [AddOffsiteWaiverSiteColumn]" -PercentComplete $perComplete
# include the AddOffsiteWaiverSiteColumn.
$scriptInc = Join-Path $fileLocationPS AddOffsiteWaiverSiteColumn.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 0.5 [CreateOffsiteWaiverRequestsView]" -PercentComplete $perComplete
# include the CreateOffsiteWaiverRequestsView.
$scriptInc = Join-Path $fileLocationPS CreateOffsiteWaiverRequestsView.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 0.6 [MigrateMigrateOffsiteWaiverData]" -PercentComplete $perComplete
# include the MigrateMigrateOffsiteWaiverData.
$scriptInc = Join-Path $fileLocationPS MigrateMigrateOffsiteWaiverData.ps1
echo $scriptInc
. $scriptInc


Write-Progress -Activity "RAMS 2.3 Deployment - Step: 1.2 [AddAdverseReportableSiteColumns]" -PercentComplete $perComplete
# include the AddAdverseReportableSiteColumns.
$scriptInc = Join-Path $fileLocationPS AddAdverseReportableSiteColumns.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 1.3 [AddAdverseReportableView]" -PercentComplete $perComplete
# include the AddAdverseReportableView.
$scriptInc = Join-Path $fileLocationPS AddAdverseReportableView.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 1.4 [CreateAFDocumentLibrary]" -PercentComplete $perComplete
# include the CreateAFDocumentLibrary.
$scriptInc = Join-Path $fileLocationPS CreateAFDocumentLibrary.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 1.5 [CreateAnimalFacilityManagerGroups]" -PercentComplete $perComplete
# include the CreateAnimalFacilityManagerGroups.
$scriptInc = Join-Path $fileLocationPS CreateAnimalFacilityManagerGroups.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 1.6 [CreateLaboratoryDocumentLibrary]" -PercentComplete $perComplete
# include the CreateLaboratoryDocumentLibrary.
$scriptInc = Join-Path $fileLocationPS CreateLaboratoryDocumentLibrary.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 1.7 [EnableVersioningOnAFDocumentLibrary]" -PercentComplete $perComplete
# include the EnableVersioningOnAFDocumentLibrary.
$scriptInc = Join-Path $fileLocationPS EnableVersioningOnAFDocumentLibrary.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 1.8 [CreateFacilitiesEditView]" -PercentComplete $perComplete
# include the CreateFacilitiesEditView.
$scriptInc = Join-Path $fileLocationPS CreateFacilitiesEditView.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 1.85 [CreateAdverseReportableView]" -PercentComplete $perComplete
# include the CreateAdverseReportableView.
$scriptInc = Join-Path $fileLocationPS CreateAdverseReportableView.ps1
echo $scriptInc
. $scriptInc


Write-Progress -Activity "RAMS 2.3 Deployment - Step: 1.9 [UpdateTMSList]" -PercentComplete $perComplete
# include the UpdateTMSList.
$scriptInc = Join-Path $fileLocationPS UpdateTMSList.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 1.95 [AddApplicationSiteColumnsForCommittees]" -PercentComplete $perComplete
# include the AddApplicationSiteColumnsForCommittees.
$scriptInc = Join-Path $fileLocationPS AddApplicationSiteColumnsForCommittees.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 2.0 [CreateFacilityCalendars]" -PercentComplete $perComplete
# include the CreateFacilityCalendars.
$scriptInc = Join-Path $fileLocationPS CreateFacilityCalendars.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 2.5 [MigrateCIRBReportComments]" -PercentComplete $perComplete
# include the MigrateCIRBReportComments.
$scriptInc = Join-Path $fileLocationPS MigrateCIRBReportComments.ps1
echo $scriptInc
. $scriptInc


Write-Progress -Activity "RAMS 2.3 Deployment - Step: 3.0 [NewSSRSList]" -PercentComplete $perComplete
# include the NewSSRSList.
$scriptInc = Join-Path $fileLocationPS NewSSRSList.ps1
echo $scriptInc
. $scriptInc


Write-Progress -Activity "RAMS 2.3 Deployment - Step: 3.1 Workflow - Notification Worflow Configuration" -PercentComplete $perComplete
$Global:script = Join-Path $fileLocationTemplate "Notification Workflow Configuration Workflow.wsp"
echo $script
Add-SiteCollectionWorkFlow -featureTemplateName "Notification Workflow Configuration Workflow.wsp" -newFeatureId "5781005a-3b95-48fe-9a13-ecf3fb2aa357" -oldFeatureId "396b98b1-64fa-463f-9c19-b2b634714bf8" -searchDisplay "*Notification Workflow Config*"

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 3.20 Remove Old WFs" -PercentComplete $perComplete
[Microsoft.SharePoint.SPWeb]$rootWeb = (Get-SiteWeb)
Import-csv .\csv\WfList.csv | ? {($_.OldWfName.Trim() -ne "") } | select OldWfName,IsFacilityLevel -Unique | % {
    #get wf name
    $oldWfName = $_.OldWfName
        
    #for facility level WFs
    if ($_.IsFacilityLevel -eq "Yes") {
        $rootWeb.Webs | % { 
            Remove-WorkFlow -wfMatchName "$oldWfName" -wfWeb $_
        }
    }
    else {
        Remove-WorkFlow -wfMatchName "$oldWfName" -wfWeb $rootWeb
    }
}

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 3.21 lwf_CommitteeBroker" -PercentComplete $perComplete
$Global:script = Join-Path $fileLocationTemplate "lwf_CommitteeBroker.wsp"
echo $script
Add-SiteCollectionWorkFlow -featureTemplateName "lwf_CommitteeBroker.wsp" -newFeatureId "c7eb2161-a399-4300-898c-1e0061aa707e" -oldFeatureId "c7eb2161-a399-4300-898c-1e0061aa707e" -searchDisplay "*wf_CommitteeBroke*"

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 3.22 Facility level workflows" -PercentComplete $perComplete
[Microsoft.SharePoint.SPWeb]$rootWeb = (Get-SiteWeb)
Import-csv .\csv\WfList.csv | select * -Unique | % {
    #get wf name
    $newWfName = $_.NewWFName
    $newFeatureId = $_.NewFeatureID
    $listName =  $_.ListName
    #for facility level WFs
    if ($_.IsFacilityLevel -eq "Yes") {
        $rootWeb.Webs | % {    
            $Global:script = Join-Path $fileLocationTemplate "$($newWfName).wsp"        
            Add-FacilityWorkflow -oldFeatureName $newWfName -featureTemplateName "$($newWfName).wsp" -newFeatureId $newFeatureId -searchDisplay $newWfName -listName $listName -unInstall $False
        }
    }
}

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 3.3 [TurnOffApplicationListThrottling]" -PercentComplete $perComplete
# include the TurnOffApplicationListThrottling.
$scriptInc = Join-Path $fileLocationPS TurnOffApplicationListThrottling.ps1
echo $scriptInc
. $scriptInc

Write-Progress -Activity "RAMS 2.3 Deployment - Step: 4 [Deploy Files]" -PercentComplete $perComplete
#Step 11 DeployFiles
# include the DeployeFiles.
$scriptInc = Join-Path $fileLocationPS DeployFiles.ps1
echo $scriptInc
. $scriptInc


$perComplete = $perComplete + $count
Write-Progress -Activity "RAMS 2.3 Deployment - Step: 5" -PercentComplete $perComplete
echo "Run Reports deployment script"
$scriptInc = Join-Path $fileLocationPS Reports_Import.ps1
echo $scriptInc
. $scriptInc -webServiceUrl "http://$reportTargetServerName" -reportFolder "RAMS Reports" -DataSourcesFolder "Data Sources" -SourceDirectory $reportSourceDirectory -overwrite $True -rdsConnStringTable $rdsConnStringTable -rdsCredentialsTable $rdsCredentialsTable


$perComplete = $perComplete + $count
Write-Progress -Activity "RAMS 2.3 Deployment - Step: 6" -PercentComplete $perComplete
echo "Apply Master Page"
$scriptInc = Join-Path $fileLocationPS MasterPageSetter.ps1
echo $scriptInc
. $scriptInc

#clean old site pages and site assets.
Remove-SitePages -sitePages manageCommittee.html
Remove-SitePages -sitePages Untitled_1.aspx
Remove-SitePages -sitePages Version.aspx

#all done
Write-Progress -Activity "RAMS 2.3 Deployment completed" -PercentComplete $perComplete -Completed 


Get-Process -Name  | Stop-Process -Verbose -Force