﻿$weburl = Get-SiteURL
$webSite = Get-SiteWeb

#create new list
$listTemplate = $webSite.ListTemplates | ? {$_.InternalName -match "custlist"}
$webSite.Lists.Add("CommitteeStatus","CommitteeStatus", $listTemplate)
$CommitteesList = $webSite.Lists.TryGetList("CommitteeStatus")

$statusValues = @(
    "Approved"
    ,"Approved with Major Modifications"
    ,"Approved with Minor Modifications"
    ,"Awaiting Revisions"
    ,"Closed"
    ,"Disapproved"
    ,"Draft"
    ,"Submitted"
    ,"Suspended"
    ,"Under Review"
)
$statusValues | % {
    $newItem = $CommitteesList.Items.Add()
    $newItem["Title"] = $_
    $newItem.Update()
}
$CommitteesList.Update()

#create new view
$fldList = @(
"ID",
"Title"
)
$CommitteesList.Views.Add("CommitteesStatusView",$fldList,"",100,$True,$True)
$CommitteesView = $CommitteesList.Views["CommitteesStatusView"]
#set sort order
$orderBy = "
<OrderBy>
    <FieldRef Name='Title' Ascending='True'/>    
</OrderBy>"
$CommitteesView.Query = $orderBy
$CommitteesView.Update()

#Turn on versioning for the Facility List
$CommitteesList.EnableVersioning = $true
$CommitteesList.EnableMinorVersions = $false

$webSite.Update()

#clean
if($webSite -ne $null) {
    $webSite.Dispose();
}