﻿#add new site column
Set-SiteColumnLookup -colName "Participating Facilities Lookup" -colStaticName "ParticipatingFacilitiesLookup" -lookupListName "Facilities" -lookupColumnName "Title" 

#add columns to application CT
Add-SiteColumnToCT -web (Get-SiteWeb) -ctName "Application CT" -sFieldInternalName "ParticipatingFacilitiesLookup" -sFieldStaticName "ParticipatingFacilitiesLookup"
Add-SiteColumnToCT -web (Get-SiteWeb) -ctName "Application CT" -sFieldInternalName "FacilitiesLookup" -sFieldStaticName "FacilitiesLookup"

#get list
$applicationList = (Get-SiteWeb).Lists.TryGetList("Application")
$facilitiesList = (Get-SiteWeb).Lists.TryGetList("Facilities")

#data migration [Facility Lookup ==> FacilitiesLookup]
$appItems = New-Object -TypeName 'System.Collections.Generic.Dictionary[System.String,System.String]'
$facilitiesList.Items | % {
    $title = $_["Title"]
    $applicationList.Items | % {
    if($_["Facility Lookup"] -match $title) {
            $appItems[$_.ID] = $title
       }
    }
}
$appItems.keys | % {
    $ID = $_
    $FacilityTitle = $appItems.Item($ID)
    $updateItem = $applicationList.Items | ? {$_.ID -eq $ID}
    if($updateItem -ne $null) {
        $facilitiesLookup = $facilitiesList.Items | ? {$_.Title -eq $FacilityTitle}
        $updateItem["Facilities Lookup"] = $facilitiesLookup.ID
        $updateItem.Update()
    }
}
$applicationList.Update()

#data migration [Participating Site ==> Participating Facilities Lookup]
$appItems = New-Object -TypeName 'System.Collections.Generic.Dictionary[System.String,System.String]'
$facilitiesList.Items | % {
    $title = $_["Title"]
    $applicationList.Items | % {
    if($_["Participating Site"] -match $title) {
            $appItems[$_.ID] = $title
       }
    }
}
$appItems.keys | % {
    $ID = $_
    $FacilityTitle = $appItems.Item($ID)
    $updateItem = $applicationList.Items | ? {$_.ID -eq $ID}
    if($updateItem -ne $null) {
        $facilitiesLookup = $facilitiesList.Items | ? {$_.Title -eq $FacilityTitle}
        $updateItem["Participating Facilities Lookup"] = $facilitiesLookup.ID
        $updateItem.Update()
    }
}
$applicationList.Update()

#update the view
$adminView = $applicationList.Views["Administrative"]
$adminView.ViewFields.Add("Participating Facilities Lookup")
$adminView.ViewFields.Add("Facilities Lookup")
$adminView.ViewFields.Remove("Facility Lookup")
$adminView.Update()



