﻿#add new site column
Set-SiteColumn -sFieldDisplayName "Expiration Date" -sFieldStaticName "ExpirationDate" -sFieldInternalName "ExpirationDate" -sFieldType Text -spFieldGroup "RAMS IRB" -showInEditForm -showInNewForm
Set-SiteColumn -sFieldDisplayName "Trainee" -sFieldStaticName "Trainee" -sFieldInternalName "Trainee" -sFieldType User -spFieldGroup "RAMS IRB" -showInEditForm -showInNewForm

#add columns to application CT
Add-SiteColumnToCT -web (Get-SiteWeb) -ctName "TMS CT" -sFieldInternalName "ExpirationDate" -sFieldStaticName "ExpirationDate"
Add-SiteColumnToCT -web (Get-SiteWeb) -ctName "TMS CT" -sFieldInternalName "Trainee" -sFieldStaticName "Trainee"

#get list
$tmsList = (Get-SiteWeb).Lists.TryGetList("TMS")
$viewFlds = @(
    "Approver Comments"
    ",First Name"
    ",Last Name"
    ",ItemID"
    ",ItemRevisionNum"
    ",ItemRevisionDate"
    ",ItemDescription"
    ",CompletionDate"
    ",CompletionStatus"
    ",MI"
    ",TMSUserID"
    ",Expiration Date"
    ",Trainee"
    ",Attachments"
    ",Modified"
    ",Created"
)

#update the view
$expirationDateFld = (Get-SiteWeb).fields | ? {$_.Title -eq "Expiration Date"}
$traineeFld = (Get-SiteWeb).fields | ? {$_.Title -eq "Trainee"}

$tmsList.Views["All Items"].ViewFields.Add($expirationDateFld)
$tmsList.Views["All Items"].ViewFields.Add($traineeFld)

$tmsList.Views["All Items"].Update()
$tmsList.Update()

